Project Chrono: chrono::ChShaftsTorqueConverter Class Reference

Public Member Functions | List of all members
chrono::ChShaftsTorqueConverter Class Reference

## Description

Class for defining a torque converter between two one-degree-of-freedom parts.

Note that is not inherited from ChShaftsTorque, because it requires a third part: the stator. The torque converter multiplies the input torque if there is slippage between input and output, then the multiplicative effect becomes closer to unity when the slippage is almost null; so it is similar to a variable-transmission-ratio gearbox, and just like any gearbox it requires a truss (the 'stator') that gets some torque. When the vehicle is coasting, the stator is always inactive, then the output torque cannot be increased. Note: it can work only in a given direction.

`#include <ChShaftsTorqueConverter.h>`

Inheritance diagram for chrono::ChShaftsTorqueConverter:
[legend]
Collaboration diagram for chrono::ChShaftsTorqueConverter:
[legend]

## Public Member Functions
| ChShaftsTorqueConverter (const ChShaftsTorqueConverter &other)
virtual ChShaftsTorqueConverter * | Clone () const override
| "Virtual" copy constructor (covariant return type).
bool | Initialize (std::shared_ptr< ChShaft > shaft_1, std::shared_ptr< ChShaft > shaft_2, std::shared_ptr< ChShaft > shaft_st)
| Initialize the torque converter, given input and output shafts to join.
ChShaft * | GetShaftInput () const
| Get the input shaft.
ChShaft * | GetShaftOutput () const
| Get the output shaft.
ChShaft * | GetShaftStator () const
| Get the stator shaft (the truss).
void | SetCurveCapacityFactor (std::shared_ptr< ChFunction > mf)
| Set the capacity factor curve, function of speed ratio R.
std::shared_ptr< ChFunction > | GetCurveCapacityFactor ()
| Get the capacity factor curve.
void | SetCurveTorqueRatio (std::shared_ptr< ChFunction > mf)
| Set the torque ratio curve, function of speed ratio R.
std::shared_ptr< ChFunction > | GetCurveTorqueRatio () const
| Get the torque ratio curve.
double | GetTorqueReactionOnInput () const
| Get the torque applied to the input shaft.
double | GetTorqueReactionOnOutput () const
| Get the torque applied to the output shaft.
double | GetTorqueReactionOnStator () const
| Get the torque applied to the stator shaft (the truss).
double | GetSpeedRatio () const
| Get the actual peed ratio, as output speed / input speed.
double | GetSlippage () const
| Get the actual slippage, for slippage = 1 complete slippage, for slippage = 0 perfect locking.
bool | StateWarningReverseFlow ()
| State warning, at last update.
bool | StateWarningWrongImpellerDirection ()
| State warning, at last update.
virtual void | Update (double mytime, bool update_assets=true) override
| Update all auxiliary data of the gear transmission at given time.
virtual void | ArchiveOut (ChArchiveOut &archive_out) override
| Method to allow serialization of transient data to archives.
virtual void | ArchiveIn (ChArchiveIn &archive_in) override
| Method to allow deserialization of transient data from archives.
Public Member Functions inherited from chrono::ChPhysicsItem
| ChPhysicsItem (const ChPhysicsItem &other)
ChSystem * | GetSystem () const
| Get the pointer to the parent ChSystem().
virtual void | SetSystem (ChSystem *m_system)
| Set the pointer to the parent ChSystem().
void | AddVisualModel (std::shared_ptr< ChVisualModel > model)
| Add an (optional) visualization model.
std::shared_ptr< ChVisualModel > | GetVisualModel () const
| Access the visualization model (if any).
void | AddVisualShape (std::shared_ptr< ChVisualShape > shape, const ChFrame<> &frame=ChFrame<>())
| Add the specified visual shape to the visualization model.
std::shared_ptr< ChVisualShape > | GetVisualShape (unsigned int i) const
| Access the specified visualization shape in the visualization model (if any).
void | AddVisualShapeFEA (std::shared_ptr< ChVisualShapeFEA > shapeFEA)
| Add the specified FEA visualization object to the visualization model.
std::shared_ptr< ChVisualShapeFEA > | GetVisualShapeFEA (unsigned int i) const
| Access the specified FEA visualization object in the visualization model (if any).
virtual ChFrame | GetVisualModelFrame (unsigned int nclone=0) const
| Get the reference frame (expressed in and relative to the absolute frame) of the visual model.
virtual unsigned int | GetNumVisualModelClones () const
| Return the number of clones of the visual model associated with this physics item.
void | AddCamera (std::shared_ptr< ChCamera > camera)
| Attach a ChCamera to this physical item.
std::vector< std::shared_ptr< ChCamera > > | GetCameras () const
| Get the set of cameras attached to this physics item.
virtual bool | IsActive () const
| Return true if the object is active and included in dynamics.
virtual bool | IsCollisionEnabled () const
| Tell if the object is subject to collision.
virtual void | AddCollisionModelsToSystem (ChCollisionSystem *coll_sys) const
| Add to the provided collision system any collision models managed by this physics item.
virtual void | RemoveCollisionModelsFromSystem (ChCollisionSystem *coll_sys) const
| Remove from the provided collision system any collision models managed by this physics item.
virtual void | SyncCollisionModels ()
| Synchronize the position and bounding box of any collsion models managed by this physics item.
virtual ChAABB | GetTotalAABB ()
| Get the entire AABB axis-aligned bounding box of the object.
virtual void | GetCenter (ChVector3d &mcenter)
| Get a symbolic 'center' of the object.
virtual void | Setup ()
| This might recompute the number of coordinates, DOFs, constraints, in case this might change (ex in ChAssembly), as well as state offsets of contained items (ex in ChMesh).
virtual void | Update (bool update_assets=true)
| As above, but does not require updating of time-dependent data.
virtual void | ForceToRest ()
| Set zero speed (and zero accelerations) in state, without changing the position.
virtual unsigned int | GetNumCoordsPosLevel ()
| Get the number of coordinates at the position level.
virtual unsigned int | GetNumCoordsVelLevel ()
| Get the number of coordinates at the velocity level.
virtual unsigned int | GetNumConstraints ()
| Get the number of scalar constraints.
virtual unsigned int | GetNumConstraintsUnilateral ()
| Get the number of unilateral scalar constraints.
unsigned int | GetOffset_x ()
| Get offset in the state vector (position part).
unsigned int | GetOffset_w ()
| Get offset in the state vector (speed part).
unsigned int | GetOffset_L ()
| Get offset in the lagrangian multipliers.
void | SetOffset_x (const unsigned int moff)
| Set offset in the state vector (position part) Note: only the ChSystem::Setup function should use this.
void | SetOffset_w (const unsigned int moff)
| Set offset in the state vector (speed part) Note: only the ChSystem::Setup function should use this.
void | SetOffset_L (const unsigned int moff)
| Set offset in the lagrangian multipliers Note: only the ChSystem::Setup function should use this.
virtual void | IntStateGather (const unsigned int off_x, ChState &x, const unsigned int off_v, ChStateDelta &v, double &T)
| From item's state to global state vectors y={x,v} pasting the states at the specified offsets.
virtual void | IntStateScatter (const unsigned int off_x, const ChState &x, const unsigned int off_v, const ChStateDelta &v, const double T, bool full_update)
| From global state vectors y={x,v} to item's state (and update) fetching the states at the specified offsets.
virtual void | IntStateGatherAcceleration (const unsigned int off_a, ChStateDelta &a)
| From item's state acceleration to global acceleration vector.
virtual void | IntStateScatterAcceleration (const unsigned int off_a, const ChStateDelta &a)
| From global acceleration vector to item's state acceleration.
virtual void | IntStateGatherReactions (const unsigned int off_L, ChVectorDynamic<> &L)
| From item's reaction forces to global reaction vector.
virtual void | IntStateScatterReactions (const unsigned int off_L, const ChVectorDynamic<> &L)
| From global reaction vector to item's reaction forces.
virtual void | IntStateIncrement (const unsigned int off_x, ChState &x_new, const ChState &x, const unsigned int off_v, const ChStateDelta &Dv)
| Computes x_new = x + Dt , using vectors at specified offsets.
virtual void | IntStateGetIncrement (const unsigned int off_x, const ChState &x_new, const ChState &x, const unsigned int off_v, ChStateDelta &Dv)
| Computes Dt = x_new - x, using vectors at specified offsets.
virtual void | IntLoadResidual_Mv (const unsigned int off, ChVectorDynamic<> &R, const ChVectorDynamic<> &w, const double c)
| Takes the M*v term, multiplying mass by a vector, scale and adds to R at given offset: R += c*M*w.
virtual void | IntLoadLumpedMass_Md (const unsigned int off, ChVectorDynamic<> &Md, double &err, const double c)
| Adds the lumped mass to a Md vector, representing a mass diagonal matrix.
virtual void | IntLoadResidual_CqL (const unsigned int off_L, ChVectorDynamic<> &R, const ChVectorDynamic<> &L, const double c)
| Takes the term Cq'*L, scale and adds to R at given offset: R += c*Cq'*L.
virtual void | IntLoadConstraint_C (const unsigned int off, ChVectorDynamic<> &Qc, const double c, bool do_clamp, double recovery_clamp)
| Takes the term C, scale and adds to Qc at given offset: Qc += c*C.
virtual void | IntLoadConstraint_Ct (const unsigned int off, ChVectorDynamic<> &Qc, const double c)
| Takes the term Ct, scale and adds to Qc at given offset: Qc += c*Ct.
virtual void | IntToDescriptor (const unsigned int off_v, const ChStateDelta &v, const ChVectorDynamic<> &R, const unsigned int off_L, const ChVectorDynamic<> &L, const ChVectorDynamic<> &Qc)
| Prepare variables and constraints to accommodate a solution:
virtual void | IntFromDescriptor (const unsigned int off_v, ChStateDelta &v, const unsigned int off_L, ChVectorDynamic<> &L)
| After a solver solution, fetch values from variables and constraints into vectors:
virtual void | InjectVariables (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChVariable objects associated with this item.
virtual void | InjectConstraints (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChConstraint objects associated with this item.
virtual void | LoadConstraintJacobians ()
| Compute and load current Jacobians in encapsulated ChConstraint objects.
virtual void | InjectKRMMatrices (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChKRMBlock objects associated with this item.
virtual void | LoadKRMMatrices (double Kfactor, double Rfactor, double Mfactor)
| Compute and load current stiffnes (K), damping (R), and mass (M) matrices in encapsulated ChKRMBlock objects.
virtual void | VariablesFbReset ()
| Sets the 'fb' part (the known term) of the encapsulated ChVariables to zero.
virtual void | VariablesQbLoadSpeed ()
| Initialize the 'qb' part of the ChVariables with the current value of speeds.
virtual void | VariablesFbIncrementMq ()
| Adds M*q (masses multiplied current 'qb') to Fb, ex.
virtual void | VariablesQbSetSpeed (double step=0)
| Fetches the item speed (ex.
virtual void | VariablesQbIncrementPosition (double step)
| Increment item positions by the 'qb' part of the ChVariables, multiplied by a 'step' factor.
virtual void | ConstraintsBiReset ()
| Sets to zero the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsBiLoad_C (double factor=1, double recovery_clamp=0.1, bool do_clamp=false)
| Adds the current C (constraint violation) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsBiLoad_Ct (double factor=1)
| Adds the current Ct (partial t-derivative, as in C_dt=0-> [Cq]*q_dt=-Ct) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsBiLoad_Qc (double factor=1)
| Adds the current Qc (the vector of C_dtdt=0 -> [Cq]*q_dtdt=Qc ) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsFbLoadForces (double factor=1)
| Adds the current link-forces, if any, (caused by springs, etc.) to the 'fb' vectors of the ChVariables referenced by encapsulated ChConstraints.
virtual void | ConstraintsFetch_react (double factor=1)
| Fetches the reactions from the lagrangian multiplier (l_i) of encapsulated ChConstraints.
Public Member Functions inherited from chrono::ChObj
| ChObj (const ChObj &other)
int | GetIdentifier () const
| Get the unique integer identifier of this object.
void | SetTag (int tag)
| Set an object integer tag (default: -1).
int | GetTag () const
| Get the tag of this object.
void | SetName (const std::string &myname)
| Set the name of this object.
const std::string & | GetName () const
| Get the name of this object.
double | GetChTime () const
| Gets the simulation time of this object.
void | SetChTime (double m_time)
| Sets the simulation time of this object.
virtual std::string & | ArchiveContainerName ()

## Additional Inherited Members
Protected Member Functions inherited from chrono::ChObj
int | GenerateUniqueIdentifier ()
Protected Attributes inherited from chrono::ChPhysicsItem
ChSystem * | system
| parent system
std::shared_ptr< ChVisualModelInstance > | vis_model_instance
| instantiated visualization model
std::vector< std::shared_ptr< ChCamera > > | cameras
| set of cameras
unsigned int | offset_x
| offset in vector of state (position part)
unsigned int | offset_w
| offset in vector of state (speed part)
unsigned int | offset_L
| offset in vector of lagrangian multipliers
Protected Attributes inherited from chrono::ChObj
double | ChTime
| object simulation time
std::string | m_name
| object name
int | m_identifier
| object unique identifier
int | m_tag
| user-supplied tag

## Member Function Documentation

## ◆ ArchiveIn()

void chrono::ChShaftsTorqueConverter::ArchiveIn | ( | ChArchiveIn & | archive_in | ) |
| overridevirtual

Method to allow deserialization of transient data from archives.

Method to allow de serialization of transient data from archives.

Reimplemented from chrono::ChPhysicsItem.

## ◆ ArchiveOut()

void chrono::ChShaftsTorqueConverter::ArchiveOut | ( | ChArchiveOut & | archive_out | ) |
| overridevirtual

Method to allow serialization of transient data to archives.

Reimplemented from chrono::ChPhysicsItem.

## ◆ Clone()

virtual ChShaftsTorqueConverter * chrono::ChShaftsTorqueConverter::Clone | ( |  | ) | const
| inlineoverridevirtual

"Virtual" copy constructor (covariant return type).

Reimplemented from chrono::ChPhysicsItem.

## ◆ GetSpeedRatio()

double chrono::ChShaftsTorqueConverter::GetSpeedRatio | ( |  | ) | const

Get the actual peed ratio, as output speed / input speed.

Assumes output has same direction as input, and slower than input otherwise exchanges input and output. For speed ratio = 0, complete slippage, for ratio=1 perfect locking.

## ◆ Initialize()

bool chrono::ChShaftsTorqueConverter::Initialize | ( | std::shared_ptr< ChShaft > | shaft_1,
|  | std::shared_ptr< ChShaft > | shaft_2,
|  | std::shared_ptr< ChShaft > | shaft_st )

Initialize the torque converter, given input and output shafts to join.

The third input shaft is the stator shaft, which should be fixed. All shafts must belong to the same ChSystem.

Parameters

  shaft_1 | input shaft
  shaft_2 | output shaft
  shaft_st | stator shaft (often fixed)

## ◆ SetCurveCapacityFactor()

void chrono::ChShaftsTorqueConverter::SetCurveCapacityFactor | ( | std::shared_ptr< ChFunction > | mf | ) |
| inline

Set the capacity factor curve, function of speed ratio R.

It is K(R)= input speed / square root of the input torque. Units: (rad/s) / sqrt(Nm)

## ◆ SetCurveTorqueRatio()

void chrono::ChShaftsTorqueConverter::SetCurveTorqueRatio | ( | std::shared_ptr< ChFunction > | mf | ) |
| inline

Set the torque ratio curve, function of speed ratio R.

It is T(R) = (output torque) / (input torque)

## ◆ StateWarningReverseFlow()

bool chrono::ChShaftsTorqueConverter::StateWarningReverseFlow | ( |  | ) |
| inline

State warning, at last update.

Tell if the torque converter is working in reverse power flow, i.e. the output turbine is running faster than input impeller shaft.

## ◆ StateWarningWrongImpellerDirection()

bool chrono::ChShaftsTorqueConverter::StateWarningWrongImpellerDirection | ( |  | ) |
| inline

State warning, at last update.

Tell if the torque converter is working with the input shaft in the reverse direction (negative speed). This is considered an abnormal behavior, and torques are forced to zero.

## ◆ Update()

void chrono::ChShaftsTorqueConverter::Update | ( | double | mytime,
|  | bool | update_assets = true )
| overridevirtual

Update all auxiliary data of the gear transmission at given time.

Reimplemented from chrono::ChPhysicsItem.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChShaftsTorqueConverter.h
- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChShaftsTorqueConverter.cpp